<template>
    <div>
        <breadcrumb-component title="Unidade de medida" :pages="breadPages"/>

        <panel-component title="Listar unidade de medida" length="6">
            <div class="form-group col-md-6">
                <router-link class="btn btn-primary" :to="{name: 'unities.create'}">
                    <i class="fa fa-plus-circle"></i> Cadastrar unidade de medida
                </router-link>
            </div>
            <div class="table-responsive col-md-12">
                <table class="table table-striped table-hover table-bordered">
                    <thead>
                    <tr>
                        <th>Nome</th>
                        <th>Sigla</th>
                        <th class="text-center" style="width: 130px">Ação</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="(unity, index) in this.unities.items" :key="index">
                        <td>{{unity.name | capitalize}}</td>
                        <td>{{unity.sigla | uppercase}}</td>
                        <td class="text-center">
                            <router-link
                                    :to="{name: 'unities.edit', params: {id: unity.id}}"
                                    class="btn btn-xs btn-info ">
                                <i class="fa fa-pencil"></i>
                            </router-link>
                            <button class="btn btn-xs btn-danger" @click.prevent="confirmDestroy(unity)">
                                <i class="fa fa-remove"></i>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </panel-component>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'unities', name: 'Unidade de medida', active: false},
                    {link: 'unities', name: 'Listar', active: true},
                ]
            }
        },

        created() {
            this.loadUnities()
        },

        computed: {
            unities() {
                return this.$store.state.unities
            }
        },

        methods: {
            loadUnities() {
                this.$store.dispatch('loadUnities')
            },

            confirmDestroy(unity) {
                this.$snotify.confirm(`Deseja realmente apagar a unidade de medida? Todos os produtos que possui essa
                unidade serão apagados: ${unity.name} ?`, 'Deletar ?', {
                    timeout: 5000,
                    showProgressBar: true,
                    closeOnClick: false,
                    pauseOnHover: true,
                    buttons: [
                        {
                            text: 'Sim', action: (toast) => {
                            this.$snotify.remove(toast.id)
                            this.destroyUnity(unity.id)
                        }
                        },
                        {
                            text: 'Não', action: (toast) => {
                            console.log('Clicked: No');
                            this.$snotify.remove(toast.id)
                        }
                        },
                    ]
                })
            },

            destroyUnity(id) {
                this.$store.dispatch('destroyUnity', id)
                    .then(() => {
                        this.loadUnities()
                        this.$snotify.success('Unidade apagada com sucesso!', 'Sucesso')
                    })
                    .catch(() => {
                        this.$snotify.error('Não foi possível apagar a unidade!', 'Error')
                    })
            }
        }
    }
</script>